/* Bibliothque ESTR dvelopp par DarkBatcher pour DOS 9.
http://dos9.franceserv.fr/ */

#ifndef ESTR_H_INCLUDED
#define ESTR_H_INCLUDED

#define DEFAULT_ESTR 129
#define FILE_END 2
#define ESTR_PTRC(a) a->ptrString

typedef struct ESTR ESTR;
typedef struct ESTR* LPESTR;

struct ESTR {
    char* ptrString;
    int iLenght;
};

ESTR* InitESTR(void);
#ifdef WIN32
    int EsGetW(ESTR* ptrESTR, HANDLE hFile);
#endif
int EsGet(ESTR* ptrESTR, FILE* ptrFile);

int EsCpy(ESTR* ptrESTR, char* ptrChaine);
int EsCat(ESTR* ptrESTR, char* ptrChaine);
int EsFree(ESTR* ptrESTR);

int EsCpyE(ESTR* ptrSource, ESTR* ptrDest);
int EsCatE(ESTR* ptrDest, ESTR* ptrSource);

#endif // ESTR_H_INCLUDED


