#ifndef _FONCTIONS_SOURCES_H
#define _FONCTIONS_SOURCES_H


int fWrite     (char *Par1, char *Par2, char *Par3);
// La fonction "fRead()" est spciale, elle est appel uniquement depuis la fonction "StringParser()"
// car elle ne fonctionne qu'avec un retour dans une variable.
int fRead      (char *FileToRead, char *StringToParse);//~~|
int fDel       (char *Par1, char *Par2, char *Par3);
int fCreate    (char *Par1, char *Par2, char *Par3);
int fMove      (char *Par1, char *Par2, char *Par3);
int fCopy      (char *Par1, char *Par2, char *Par3);
int fRun       (char *Par1, char *Par2, char *Par3);
int fExist     (char *Par1, char *Par2, char *Par3);

int dDel       (char *Par1, char *Par2, char *Par3);
int dCreate    (char *Par1, char *Par2, char *Par3);
int dMove      (char *Par1, char *Par2, char *Par3);
int dCopy      (char *Par1, char *Par2, char *Par3);
int dExist     (char *Par1, char *Par2, char *Par3);

int pDel       (char *Par1, char *Par2, char *Par3);
int pSet       (char *Par1, char *Par2, char *Par3);
int pExist     (char *Par1, char *Par2, char *Par3);
int pWait      (char *Par1, char *Par2, char *Par3);

int mMove      (char *Par1, char *Par2, char *Par3);
int mLeft      (char *Par1, char *Par2, char *Par3);
int mRight     (char *Par1, char *Par2, char *Par3);

int kSend      (char *Par1, char *Par2, char *Par3);
int kDown      (char *Par1, char *Par2, char *Par3);
int kUp        (char *Par1, char *Par2, char *Par3);

int message    (char *Par1, char *Par2, char *Par3);
int sleep      (char *Par1, char *Par2, char *Par3);
int random     (char *Par1, char *Par2, char *Par3);

int sSetErr    (char *Par1, char *Par2, char *Par3);
int sExitCode  (char *Par1, char *Par2, char *Par3);
// La fonction "sGetOsInfo()" est spciale, elle est appel uniquement depuis la fonction "StringParser()"
// car elle ne fonctionne qu'avec un retour dans une variable.
int sGetOsInfo (char *InfoToGet, char *StringToParse);//~~|
int sWriteErr  (char *Par1, char *Par2, char *Par3);
int sSetEnv    (char *Par1, char *Par2, char *Par3);
// La fonction "sGetEnv()" est spciale, elle est appel uniquement depuis la fonction "StringParser()"
// car elle ne fonctionne qu'avec un retour dans une variable.
int sGetEnv    (char *VarEnvToGet, char *StringToParse);//~~|

// Les fonction string sont spciales, elles sont appels uniquement depuis la fonction "StringParser()"
// car elles ne fonctionnent qu'avec un retour dans une variable.
int strInStr   (char *String, char *SubString, char *CaseSens, char *StringToParse);//~~|
int strLeft    (char *String, char *Count, char *StringToParse);//~~|
int strRight   (char *String, char *Count, char *StringToParse);//~~|
int strLen     (char *String, char *StringToParse);//~~|
int strReplace (char *String, char *SubString1, char *SubString2, char *StringToParse);//~~|

int console    (char *Par1, char *Par2, char *Par3);
int cWrite     (char *Par1, char *Par2, char *Par3);
int cClear     (char *Par1, char *Par2, char *Par3);
// La fonction "cGet()" est spciale, elle est appel uniquement depuis la fonction "StringParser()"
// car elle ne fonctionne qu'avec un retour dans une variable.
int cGet       (char *StringToParse);//~~|
int cTitle     (char *Par1, char *Par2, char *Par3);
int cExec      (char *Par1, char *Par2, char *Par3);

int isDeclared (char *Par1, char *Par2, char *Par3);

int wActivate  (char *Par1, char *Par2, char *Par3);
int wWait      (char *Par1, char *Par2, char *Par3);
int wSetPos    (char *Par1, char *Par2, char *Par3);
int wGetPos    (char *Par1, char *Par2, char *Par3);
int wSetSize   (char *Par1, char *Par2, char *Par3);
int wGetSize   (char *Par1, char *Par2, char *Par3);
int wExist     (char *Par1, char *Par2, char *Par3);

#endif


